from harkpython import harkbasenode
import math
import csv

class HarkNode(harkbasenode.HarkBaseNode):
    def __init__(self):
        # 賦予輸出的三個值對應名稱與形式
        self.outputNames=("all", "x0", "x1", "x2",)  # three output terminal named "all", "x0", "x1", "x2"
        self.outputTypes=("vector_source", "vector_float", "vector_float", "vector_float",)  # the type is vector_float.
    def calculate(self):
        # 最大的問題為無法單獨取出字串或字典中的值，只能在賦予output值時就將所需參數取出
        # 先取出self.input的字串長度後，
        ###
        # self.input形式為[{'id': 1, 'x': [1.2000000476837158, 0.0, 0.0], 'power': 25.10016632080078},
        #                  {'id': 3, 'x': [-0.6000000238418579, 1.039199948310852, 0.0], 'power': 32.355926513671875}]

        self.outputValues["all"] = self.input
        all = self.outputValues["all"]
        self.outputValues["x0"] = []
        self.outputValues["x1"] = []
        self.outputValues["x2"] = []
        print("==========")


        ###寫入csv並輸出x0 x1 x2###
        #檔案位置
        csv_file_path = "coordinate.csv"
        # 開啟 CSV 檔案，指定寫入模式
        with open(csv_file_path, 'w', newline='') as csv_file:
            # 創建 CSV 寫入器
            csv_writer = csv.writer(csv_file)
            #將列表寫入csv
   
            #歸零次數
            c = 0
            if len(self.input) > 0:
                for num in all:
                    #將self.input中的值給outputValues               
                    self.outputValues["x" + str(c)] = num["x"]
                    x = self.outputValues["x" + str(c)]

                    # 提供一個包含浮點數的列表作為元素的列表，直接將x寫入csv會出錯
                    data_to_write = [x]
                    #將[x]寫入csv
                    for row in data_to_write:
                        csv_writer.writerow(row)
                    
                    c = c + 1
                    print(x)
            
            else:
                print("0")


        
        
       

            
            